<template>
  <div class="forgot-page">
    <div class="panel-break"><h4>ВОССТАНОВИТЬ ПАРОЛЬ</h4></div>
    <div class="login-wrapper container">
      <div class="row">
        <div class="forgot-pw-form">
          <div class="form-group">
            <label for="password">ПАРОЛЬ</label>
            <input type="password" class="main-input" :class="{'invalid': checkRequired(forgotDetails.password)}" v-model="forgotDetails.password" name="password">
          </div>

          <div class="form-group">
            <label for="password">ПОДТВЕРЖДЕНИЕ ПАРОЛЯ</label>
            <input type="password" class="main-input" :class="{'invalid': checkRequired(forgotDetails.passwordConfirm)}" v-model="forgotDetails.passwordConfirm" name="passwordConfirm">
          </div>
          <p class="errorMessage" v-if="error" v-text="error"></p>
          <button class="action-button black-button" @click="resetPassword">ВОССТАНОВИТЬ</button>
        </div>
      </div>
    </div>
    <modal :header="'Forgot Password'" :isShow="showModal" v-if="showModal" @close="showModal = false">
      <div slot="body">
        <p>Успешно установлен новый пароль. Нажмите <router-link :to="`/login`" >здесь</router-link> чтобы перейти на страницу авторизации!</p>
        
      </div>

      <div slot="footer">
        
      </div>
    </modal>
  </div>
</template>
<script>
import Modal from "../shared/Modal";
export default {
  name: "forgot-password",
  data() {
    return {
      error: '',
      showRequired: false, showModal: false,
      forgotDetails: {
        'userId': '',
        'password': '',
        'passwordConfirm': ''
      }
    }
  },
  components: {
    Modal
  },
  methods: {
    checkRequired(i) {
      return this.showRequired && !i || this.showRequired && this.forgotDetails.password.length < 4 || this.showRequired && this.forgotDetails.password !== this.forgotDetails.passwordConfirm;
    },
    resetPassword(e) {
      this.error = '';
      this.showRequired = false;
      if (!this.forgotDetails.password || !this.forgotDetails.passwordConfirm) {
        this.showRequired = true;
        return this.error = 'Пожалуйста, заполните обязательные поля';
      } else if (this.forgotDetails.password.length < 4) {
        this.error = `Пароль должен состоять минимум из 4 символов`;
        return this.showRequired = true;
      } else if (!passwordsDontMatch(this.forgotDetails.password, this.forgotDetails.passwordConfirm)) {
        this.error = `Пароли не совпадают`;
        return this.showRequired = true;
      }
      e.target.disabled = true;
      this.$http
        .put(`${process.env.VUE_APP_BASE_URL}/forgot-password/${this.forgotDetails.userId}`, this.forgotDetails)
        .then(response => {
          this.showModal = true;
          this.forgotDetails.password = '';
          this.forgotDetails.passwordConfirm = '';
          this.forgotDetails.userId = '';
        })
        .catch(error => {
          e.target.disabled = false;
          this.error = 'Произошла ошибка';
        });
    }
  },
  mounted() {
    this.$http.get(`${process.env.VUE_APP_BASE_URL}/forgot-password/${this.$route.params.token}`).then(resp => {
      this.forgotDetails.userId = resp.data;
    }).catch(err => {
      this.error = 'Произошла ошибка';
    });
  }
};
function passwordsDontMatch(p1, p2) {
  return p1 === p2;
}
</script>
<style lang="scss">
  .forgot-page {
    margin-bottom: 50px;
    .forgot-pw-form {
      margin: 0 auto;
    }
  }


</style>
